import QtQuick 2.12

Rectangle {
   id: _keypadrectangle
   signal clicked(string text, int iKey)
   property string baseColor: "#383533"
   property alias active: _keypadrectangle.visible
   property double keySpacing:  10
   property string seperator: ","
   width: _keygrid.width + _controlKeys.width
   height: _keygrid.height
   color:   "transparent" //baseColor
   visible: false


   onClicked: { parent.clicked(text, iKey);  }

    MessageFrame {
        id: _PadFrame
        visible: false
        borderWidth: 1
        baseColor: "#A0A0A0" //"lightgray"

    }
   Grid {
      id: _keygrid
      signal clicked(string text, int iKey)
      columns: 3
      columnSpacing: _keypadrectangle.keySpacing
      rowSpacing: _keypadrectangle.keySpacing
      padding: _keypadrectangle.keySpacing

      KeyPadButton { text: "7"; iHWKey: Qt.Key_7 }
      KeyPadButton { text: "8"; iHWKey: Qt.Key_8 }
      KeyPadButton { text: "9"; iHWKey: Qt.Key_9 }
      KeyPadButton { text: "4"; iHWKey: Qt.Key_4 }
      KeyPadButton { text: "5"; iHWKey: Qt.Key_5 }
      KeyPadButton { text: "6"; iHWKey: Qt.Key_6 }
      KeyPadButton { text: "1"; iHWKey: Qt.Key_1 }
      KeyPadButton { text: "2"; iHWKey: Qt.Key_2 }
      KeyPadButton { text: "3"; iHWKey: Qt.Key_3 }
      KeyPadButton { text: ""; bAnimation: false }
      KeyPadButton { text: "0"; iHWKey: Qt.Key_0 }
      KeyPadButton { text: _keypadrectangle.seperator; iHWKey: Qt.Key_Comma }

      onClicked: { parent.clicked(text, iKey); }
   }
   Column{
      id: _controlKeys
      signal clicked(string text, int iKey)
      anchors.left: _keygrid.right
      anchors.leftMargin:  -_keypadrectangle.keySpacing
      padding: _keypadrectangle.keySpacing
      spacing: _keypadrectangle.keySpacing
      rightPadding: 0
      KeyPadButton { text: ""; source: globalPathToImages+"control_backspace.svg"; iImageHeight: 16; iImageWidth: 32; iHWKey: Qt.Key_Backspace}
      KeyPadButton { text: ""; source: globalPathToImages+"control_trash.svg"; iImageHeight: 32; iImageWidth: 32; iHWKey: Qt.Key_Clear}
      KeyPadButton { text: ""; source: globalPathToImages+"control_enter.svg"; height: 128+_keypadrectangle.keySpacing; iImageHeight: 24; iImageWidth: 40; iHWKey: Qt.Key_Enter; }
/*
      KeyPadButton { text: ""; bAnimation: false; source: globalPathToImages+"backspace-868482.svg"; width: 76; iImageHeight: 16; iImageWidth: 32; iHWKey: Qt.Key_Backspace}
      KeyPadButton { text: ""; bAnimation: false; source: globalPathToImages+"icons8-trash.svg"; width: 80;iImageHeight: 32; iImageWidth: 32; iHWKey: Qt.Key_Clear}
      KeyPadButton { text: ""; bAnimation: false;source: globalPathToImages+"enter-868482.svg"; width: 80; height: 128+8; iImageHeight: 16; iImageWidth: 32; iHWKey: Qt.Key_Enter}
      */
      onClicked: { parent.clicked(text, iKey); }
   }

}
