import QtQuick 2.9
import QtQuick.Controls 2.2
import cti_module 1.0

import QtQuick.VirtualKeyboard 2.2
import QtQuick.VirtualKeyboard.Settings 2.2
import QtQuick.VirtualKeyboard.Styles 2.2

TerminalPage {
   id:        _inputPINPage;
   property alias inputPinField_text:           _inputField.text
   property alias inputPinTextField_readOnly:   _inputField.readOnly
   property bool passwordMode:                     true
   property string inputPinreg_exp:             "^[0-9]+$"
   property string inputpinTxtMessage:          ""
   property string inputPinCallToActiontext:    ""

   onVisibleChanged:
   {
      if (visible)
      {
         sharedStatusClock_visible= false
         if(passwordMode)
            _inputField.echoMode= TextInput.Password
         else
            _inputField.echoMode = TextInput.Normal
      }
   }

   TimeSmall{ // Uhr ohne Datum
      id: _time
      anchors.right:          _helpPageLeftInput.right
      anchors.topMargin:      0
      anchors.rightMargin:    0
      visible:    mainLayout.desingnTouch
   }

   DateSmall { // nur Datum
      id: _date
      anchors.left:           _helpPageLeftInput.left
      anchors.leftMargin:     0
      anchors.topMargin:      0
      visible:                mainLayout.desingnTouch
   }
   Rectangle{
      id:         _helpPageLeftInput
      width:      mainLayout.widthCallToAction       //
      height:     _inputPINPage.height-( 2*mainLayout.layoutTopMargin*mainLayout.desingnTouch)
      color:      "transparent"
      x:          mainLayout.layoutTopMargin*mainLayout.desingnTouch+( (mainLayout.width/2-mainLayout.widthCallToAction/2) *!mainLayout.desingnTouch)
      y:          mainLayout.layoutTopMargin*mainLayout.desingnTouch
      z:          20
      visible:    mainLayout.desingnTouch

      MessageArea {
         id:                        _inputTxtMessage;
         y:                         mainLayout.layoutCellSpace*2*mainLayout.desingnTouch+mainLayout.layoutCellHeight*!mainLayout.desingnTouch;
         horizontalAlignment :      mainLayout.messageAreaTextAlign// Text.AlignLeft;
         anchors.horizontalCenter:  _helpPageLeftInput.horizontalCenter;
         width:                     _helpPageLeftInput.width
         text:                      _inputPINPage.inputpinTxtMessage

      }
      CallToActionArea {
         id:                  _inputCallToAction;
         width:               _helpPageLeftInput.width
         textAlignmentH:      mainLayout.callToActionTextAlign
         height:              mainLayout.heightCallToAction
         anchors.top:         _inputTxtMessage.bottom
         anchors.topMargin:   mainLayout.callToActionTopMargin
      }
/*
//debug
         Rectangle{ border.width: 2; border.color: "yellow"; anchors.fill: _inputTxtMessage; }
         Rectangle{ border.width: 2; border.color: "red"; anchors.fill: _inputCallToAction; }
// */
      ControlButton {
         myButtonId:       "FKT_Key_Clear"
         iHWKey:           1067
         text:             mainLayout.textControlButton_Home//"Home"
         width:            140
         anchors.bottom:   _helpPageLeftInput.bottom
         buttonTextColor:  mainLayout.controlButtonTextColor
         pixelSize:        mainLayout.fontPixelSizeKeyText
         visible:          mainLayout.desingnTouch
      }
      ControlButton {
         myButtonId:       "FKT_Key_Info"
         iHWKey:           1073
         text:             mainLayout.textControlButton_Info//"Info"
         width:            140
         x:                150
         anchors.bottom:   _helpPageLeftInput.bottom
         buttonTextColor:  mainLayout.controlButtonTextColor
         pixelSize:        mainLayout.fontPixelSizeKeyText
         visible:          mainLayout.desingnTouch
      }

   }
//    Rectangle{ color: "transparent" ;      border.width: 2;      border.color: "green"; anchors.fill:_helpPageLeftInput }

   MessageArea {
      id:    _inputTxtMessage480;
      y:     100//mainLayout.layoutCellHeight + mainLayout.layoutCellSpace;
      z:     2
      width:    mainLayout.widthCallToAction+mainLayout.layoutCellWidth+mainLayout.layoutCellSpace*3
      height:                       mainLayout.layoutCellHeight+mainLayout.layoutCellSpace*!mainLayout.desingnTouch
      anchors.horizontalCenter: parent.horizontalCenter;
      visible: !mainLayout.desingnTouch
      text:                   _inputPINPage.inputpinTxtMessage
    }
// Debug    Rectangle{      color: "transparent";  border.width: 2;  border.color: "red";  anchors.fill:  _inputTxtMessage480 }
   CallToActionArea {
      id: _inputCallToAction480;
        width:    mainLayout.widthCallToAction+mainLayout.layoutCellWidth+mainLayout.layoutCellSpace*3
        visible: !mainLayout.desingnTouch
        text:  _inputPINPage.inputPinCallToActiontext
    }

   TextField  {
      id:               _inputField
      font.pixelSize:   (mainLayout.fontPixelSizeDefault ? mainLayout.fontPixelSizeDefault : 16)
      color:            mainLayout.colorText;
      y: 50 + (!mainLayout.desingnTouch*mainLayout.layoutCellSpace)
      anchors.right:          _inputPINPage.right
      anchors.rightMargin:    mainLayout.desingnTouch*mainLayout.layoutTopMargin+(!mainLayout.desingnTouch*(_inputPINPage.width/2-_inputField.width/2))
      width:   mainLayout.desingnTouch*(_inputPINPage.width/2-mainLayout.layoutTopMargin*2)+(!mainLayout.desingnTouch*_inputCallToAction480.width)
      horizontalAlignment: TextInput.AlignHCenter;
//      inputMethodHints: Qt.ImhFormattedNumbersOnly
     inputMethodHints: Qt.ImhDigitsOnly
//          inputMethodHints: Qt.ImhDialableCharactersOnly
//      validator: RegExpValidator{regExp: /^[0-9,/]+$/ }
      validator: RegExpValidator { regExp: RegExp(inputPinreg_exp) }


      focus:                     _inputPINPage.visible
      cursorVisible:             activeFocus
      background: Rectangle {
                     implicitWidth: 10
                     implicitHeight: 10
                      color:           "#323232"
                      anchors.fill:    _inputField
         }

      onAccepted:
      {  console.log("----------->>Edit finished :", focusReason, "Text: ", _inputField.text, "inputMethodHints: ", _inputField.inputMethodHints );
               qmlkeypressSignaltolib(_inputField.text, 25, 0);
      }

   }

   Rectangle{      color: "transparent";  border.width: 2;  border.color: "gray";  anchors.fill:  _inputField }

   InputPanel {
         id: inputPanelDigits
         width:   parent.width*1.3
         height:  _inputPINPage.height-2*mainLayout.layoutTopMargin
         x: mainLayout.layoutCellHeight
         y: _inputPINPage.height
//         y: mainLayout.layoutCellSpace

         z: 99
         visible: mainLayout.gKeyboard_enabled && mainLayout.desingnTouch

         states: State {
            name: "visible"
            when: inputPanelDigits.active
//            PropertyChanges {  target: _HexKeyPad;  y: mainLayout.height - _HexKeyPad.height - mainLayout.layoutHeightInfoPanel }
//            PropertyChanges {  target: myMainPage1;  y: mainLayout.layoutHeightInfoPanel*2 }
//            PropertyChanges {  target: inputPanelDigits;  y: _inputPINPage.y  }
            PropertyChanges {  target: inputPanelDigits;  y: mainLayout.layoutCellSpace}

        }
        transitions: Transition {
            from: ""
            to: "visible"
            reversible: true
            ParallelAnimation {
                NumberAnimation {
                    properties: "y"
                    duration: 300
                    easing.type: Easing.InOutQuad
                }
            }
        }

         Component.onCompleted: {
            keyboard.style.keyboardBackground = null;        // the keyboard background
            keyboard.style.selectionListBackground = null;   // the horizontal bar at the// top of the keyboard
            VirtualKeyboardSettings.locale = mainLayout.customLocale
            // console.log("K-width: ", width, "y-pos: ", _inputPINPage.y )
         }

    }

}   // _inputPINPage
