import cti_module 1.0
import QtQuick.Controls 2.2
import QtQuick 2.12

TerminalPage {
   id:                                          _selectListPage;
   property int iSelectedIndex:     -1
   property alias selectListTxtMessage:         _selectListTxtMessage.text
   property alias selectListCallToAction:       _selectListCallToAction.text

   property alias selectListModelSource:        _jsonDataModel.source
   property alias selectListModelData:          _jsonDataModel.json
   property alias selectListModelQuery:         _jsonDataModel.query // aktuell unbenutzt, Filtern geht in C# besser
   color: mainLayout.listButtonFillColor

   function resetListView()
   {
/* Original
      // Reset Auswahl: kein Element gewaehlt, Ansicht auf Anfang
      _selectionGrid.positionViewAtIndex(0, GridView.Beginning)
      if(_selectionGrid.currentIndex >= 0)
         _selectionGrid.currentItem.aliasState = "DESELECTED"
      _selectionGrid.currentIndex = -1
*/
      iSelectedIndex=0;
      for (var s = 0; s < _selectionGrid.count; s++)
      {
         if(_selectionGrid.model.get(s).isSelected)
         {
            iSelectedIndex=s;
            _selectionGrid.currentIndex =s
         }
      }
      // Reset Auswahl: kein Element gewaehlt, Ansicht auf Anfang
     _selectionGrid.positionViewAtIndex( iSelectedIndex, GridView.Beginning)
      _selectionGrid.currentIndex = iSelectedIndex
   }

   onVisibleChanged:
   {
      resetListView()
   }
   TimeSmall{ // Uhr ohne Datum
      id: _time
      anchors.right:          _leftPage.right
      anchors.topMargin:      0
      anchors.rightMargin:    0
   }

   DateSmall { // nur Datum
      id: _date
        anchors.left:         _leftPage.left
        anchors.topMargin:    0
        anchors.leftMargin:   0
   }

// help json tags: https://goessner.net/articles/JsonPath/
// Kopie, mit Aenderungen git: https://github.com/ubuntudroid/qml-utils
// git Original: https://github.com/kromain/qml-utils
   JSONListModel {
       id:              _jsonDataModel
      onDataChanged:
      {
         resetListView()
      }

   }


   Rectangle{
      id:            _leftPage
      width:         _selectListPage.width/2 - 3*mainLayout.layoutTopMargin +6// 296?
      height:        _selectListPage.height- 2*mainLayout.layoutTopMargin-8
      color:         "transparent"
      x:             mainLayout.layoutTopMargin
      y:             mainLayout.layoutTopMargin+4
// Debug Rectangle { anchors.fill: _leftPage; border.width: 4;       color:         "transparent";  border.color: "blue"}
// StatusText mit Link auf Text mainLayout.textStatusMessage, globaler Statustext entfernt
      StatusText {
         id:                  _sharedTxtStatusSelectList;
         font.pixelSize:      mainLayout.fontPixelSizeCallToAction
         width:               _leftPage.width
         anchors.left:        _leftPage.left;
         text:                mainLayout.textStatusMessage
         visible:             _selectListPage.visible
         anchors.top:            _leftPage.top
         anchors.topMargin:      mainLayout.layoutCellSpace
      }
// Debug Rectangle { anchors.fill: _sharedTxtStatusSelectList;       color:         "transparent"; border.width: 3; border.color: "green"}
      MessageArea {
         id:                     _selectListTxtMessage;
         height:                 mainLayout.layoutCellHeight*2 //+ mainLayout.layoutCellSpace;
         horizontalAlignment:    Text.AlignLeft;
         anchors.left:           _leftPage.left;
         width:                  _leftPage.width
         anchors.top:            _sharedTxtStatusSelectList.bottom
         anchors.topMargin:      mainLayout.fontPixelSizeDefault//layoutCellSpace

      }
// Debug Rectangle { anchors.fill: _selectListTxtMessage; border.width: 2;       color:         "transparent";  border.color: "red"}
      CallToActionArea {
         id:                     _selectListCallToAction
         width:                  _leftPage.width
         textAlignmentH:         Text.AlignLeft;
         height:                 mainLayout.layoutCellHeight+mainLayout.layoutCellSpace
         anchors.left:           _leftPage.left;
         anchors.top:            _selectListTxtMessage.bottom
         anchors.topMargin:      mainLayout.fontPixelSizeDefault//layoutCellSpace

      }
// Debug Rectangle { anchors.fill: _selectListCallToAction; border.width: 2;       color:         "transparent";border.color: "yellow"}

      ControlButton {
         myButtonId:             "FKT_Key_Clear"
         iHWKey:                 1067
         text:                   mainLayout.textControlButton_No
         width:                  140
         anchors.bottom:         _leftPage.bottom
         buttonTextColor:        mainLayout.controlButtonTextColor
         pixelSize:              mainLayout.fontPixelSizeKeyText
// falls notwendig, onKlicked -> Reset: _selectionGrid.currentItem.sState = "RELEASED"
      }

      ControlButton {
         myButtonId:             "FKT_Key_OK"
         iHWKey:                 1079
         text:                   mainLayout.textControlButton_OK
         width:                  140
         x:                      150
         anchors.bottom:         _leftPage.bottom
         buttonTextColor:        mainLayout.controlButtonTextColor
         pixelSize:              mainLayout.fontPixelSizeKeyText
// falls notwendig, onKlicked -> Reset: _selectionGrid.currentItem.sState = "RELEASED"
      }
   }

   GridView {
      id:                        _selectionGrid
      width:                     _selectListPage.width/2-mainLayout.layoutTopMargin-6;
      height:                    _selectListPage.height-2*mainLayout.layoutTopMargin
      anchors.top:               _selectListPage.top
      anchors.topMargin:         mainLayout.layoutTopMargin+4
      anchors.right:             _selectListPage.right
      anchors.rightMargin:       mainLayout.layoutTopMargin
      clip:                      true;
      snapMode:                  GridView.SnapToRow;
      currentIndex:              -1 // nichts ausgewält beim start
      cellWidth:                 (_selectionGrid.width/mainLayout.listNumColumn)-4
      cellHeight:                mainLayout.listCellHeight
      model:                     _jsonDataModel.model

      delegate:   Item {
            x:                      mainLayout.bookCellSpacing/2
            y:                      mainLayout.bookCellSpacing/2
            width:                  _selectionGrid.cellWidth
            height:                 _selectionGrid.cellHeight
            property alias aliasButtonID: _listelem.myButtonId

            SelectListEntry {
               id: _listelem
               listEntryText:          model.ButtonText
               myButtonId:             model.ButtonID
               isEnabled:              model.enable
               textColor:              mainLayout.listButtonTextColor
               width:                  _selectionGrid.cellWidth-9-4
               height:                 _selectionGrid.cellHeight-mainLayout.listCellSpacing
               anchors.centerIn:  parent
               colorPreselect:          model.ColorPreselect ? model.ColorPreselect : ""
           MouseArea {
            id: mArea
            anchors.fill:        parent
             onPressed:
               {
                  _selectionGrid.currentIndex = index;
                  qmlkeypressSignaltolib(_selectionGrid.currentItem.aliasButtonID, 1084, 0);
               }
           }
         }// ListEntry

      }// Item
      ScrollIndicator.vertical: ScrollIndicator {
         id: _scrollBarGrid
         size: 0.2
         active: true;
         visible: (_selectionGrid.count>10)
         contentItem: Rectangle {
            implicitWidth:  6
            implicitHeight: 100
            radius: width / 2
            color:  Qt.lighter(mainLayout.listButtonFillColor, 1.6)
         }
         background: Rectangle {
            id:      _ScrollBackRecGrid
            color:  Qt.darker(mainLayout.listButtonFillColor, 1.6)
         }
      }
      onMovementStarted:
      {
         // TimeKeeper Key
         qmlkeypressSignaltolib("FKT_Key_Move_Start", 1084,1)
      }
      onMovementEnded:
      {
         qmlkeypressSignaltolib("FKT_Key_Move_End", 1084,1)
      }

   } // GridView
//     Rectangle { border.color: "yellow";      border.width: 1; anchors.fill: _selectionGrid; color: "transparent" }
//     Rectangle { border.color: "red";      border.width: 1; anchors.fill: _leftPage; color: "transparent" }
}   // _selectListPage
