﻿define([], function () {

    var controllerName = "NetzwerkEinstellung";

    function enableDisableInputs() {
        //wenn WLAN aktiv, LAN-DHCP nicht waehlbar
        if ($('#IsWlanActive').prop('checked') == true) {
            $("#Lan_DHCPisTrue").prop("disabled", true);
        }
        else {
            $("#Lan_DHCPisTrue").prop("disabled", false);
        }

        var checkedRadioValue_Lan = $('input:radio[id = "Lan_DHCPisTrue"]:checked').val();
        if (checkedRadioValue_Lan) {
            $('.Lan_display-ip-manual').prop('disabled', true);
        }
        else {
            $('.Lan_display-ip-manual').prop('disabled', false);
        }

        var checkedRadioValue_WLan = $('input:radio[id = "WLan_DHCPisTrue"]:checked').val();
        if (checkedRadioValue_WLan) {
            $('.WLan_display-ip-manual').prop('disabled', true);
        }
        else {
            $('.WLan_display-ip-manual').prop('disabled', false);
        }
    }

    function openModal() {

        $("#btn-reload").prop('disabled', true)
        $("#computeDialog").modal("show");

        _ScanWirelessLan()
    }

    function closeModal() {
        $("#computeDialog").modal('hide');
        $("#btn-reload").prop('disabled', false);
    }

    function _ScanWirelessLan() {

        $("#wlanSsids").empty();
        $("#waitScanWlan").removeClass("hidden");
        $("#dialogNoWlan").addClass("hidden")
        $("#dialogErrorWlan").addClass("hidden");
        $("#dialogErrorWlan").empty();

        $.ajax({
            url: controllerName + '/ScanWirelessLan',
            dataType: "json",
            type: 'GET',
            success: function (data) {
                if ($.trim(data)) { 
                    for (var i = 0; i < data.length; i++)
                    {
                        _ShowSsid(data[i]);
                    }
                }
                else {
                    $("#dialogNoWlan").removeClass("hidden")
                }
            },
            error: function (error) {
                $("#dialogErrorWlan").removeClass("hidden");
                if (error != null) {
                    $("#dialogErrorWlan").html(error.responseText);
                }
                else {
                    $("#dialogErrorWlan").html("Error");
                }
            },
            complete: function () {
                $("#waitScanWlan").addClass("hidden");
            }
        });
    }

    function _ShowSsid(item) {
        var itemId = "Ssid_" + item.replace(/[^a-zA-Z0-9_]|\W+|\s+/gi, '').trim();
        if (itemId.length <= 0) {
            return;
        }

        $("#wlanSsids").append('<li class="list-group-item ssid-item" id="' + itemId + '">' + item + '</li>');
        $("#" + itemId).click(function () {
            var selectedText = $(this).text();
            $("#Ssid").val(selectedText);
            $("#btn-closeModal").trigger("click");
        });
    }

    function _SetLanSettings() {
        if ($('#IsWlanActive').prop('checked') == true) {
            $("#Lan_DHCPisFalse").prop("checked", true);

            $('#Lan_IpAdresse').val("192.168.0.1")
            $('#Lan_Netzmaske').val("255.255.0.0")
            $('#Lan_Gateway').val("")
            $('#Lan_DnsServer').val("")
        }
        else {
            $("#Lan_DHCPisTrue").prop("disabled", false);
        }
        enableDisableInputs()
    }

    function _showTabLan() {
        _SetLanSettings();

        $("#tabLanLink").click();
    }

    function _ignoreKeyEnter(event) {

        var keyPressed = event.keyCode;
        if (keyPressed === 13) {
            event.preventDefault();
            return false;
        } 
    }

    return {
        init: function () {

            $('input:radio[name = "Lan.IsDhcp"]').change(enableDisableInputs);
            $('input:radio[name = "WLan.IsDhcp"]').change(enableDisableInputs);

            $("#btn-openModal").click(function () {
                openModal();
            });

            $("#btn-closeModal").click(function () {
                closeModal();
            });

            $("#btnWlanWeiter").click(function () {
                _showTabLan();
            });
            $("#formNetwork").on("keydown", function (event) {
                _ignoreKeyEnter(event);
            });

            $("#IsWlanActive").change(_SetLanSettings);

            $(".toggle-password").click(function () {
                $(this).toggleClass("glyphicon-eye-open glyphicon-eye-close");
                var input = $($(this).attr("toggle"));
                if (input.attr("type") == "password") {
                    input.attr("type", "text");
                } else {
                    input.attr("type", "password");
                }
            });

            enableDisableInputs();
        }
    }
})